// 2008 andrewl

// OS
#include <windows.h>

// cstdlib
#include <stdio.h>

__declspec(thread) int thread_var0 = 0;
__declspec(thread) int thread_var1 = 1;
__declspec(thread) int thread_var2 = 2;
__declspec(thread) int thread_var3 = 3;

DWORD WINAPI proc_Thread(PVOID param)
{
    printf("Thread here:\n");
    printf("I should see thread values 0 1 2 3: %d %d %d %d\n", thread_var0, thread_var1, thread_var2, thread_var3);

    // this shouldn't affect other threads' values
    thread_var0 += 0xDEADBEEF;
    thread_var1 += 0xDEADBEEF;
    thread_var2 += 0xDEADBEEF;
    thread_var3 += 0xDEADBEEF;

    Sleep(1000);

    return 0;
}


void main(void)
{ 
    HANDLE handles[8];

    for(int i=0; i<8; ++i)
        handles[i] = CreateThread(0, 0, proc_Thread, 0, 0, 0);

    for(int i=0; i<8; ++i)
    {
        WaitForSingleObject(handles[i], INFINITE);
        CloseHandle(handles[i]);
    }
}


